#include <ell/StateCollector.hh>

#include "ell/rna/DW_RNA.hh"
#include <biu/RandomNumberFactory.hh>
#include "ell/rna/S_RNAfe_SingleM.hh"

using namespace std;
using namespace biu;
using namespace ell;

int main(int argc, char **argv) {

	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test function : DW_RNA_MorganHiggs \n"
				<<"===========================================" <<std::endl;

	
	RandomNumberGenerator* rng = new RNG_LCG();
	RNF::setRNG( rng );
	RNF::getRNG().setSeed(1);
	
	string sequence =   "GCAUUCUACCGAAAGCGC";
	string structureA = "((.(((....)))...))";
	string structureB = "((.((.(....)))))..";
	
	S_RNAfe_SingleM rnaA(sequence,structureA);
	S_RNAfe_SingleM rnaB(sequence,structureB);
	SC_Outstream scc(std::cout, std::string("\n"));
	
	DW_RNA_MorganHiggs dw(100);
	
	cout <<" --> DW_RNA_MorganHiggs(100).walk( "
		<<rnaA.toString() <<", "
		<<rnaB.toString() <<" )\n\n";
	dw.walk( &rnaA, &rnaB, &scc);	
	
	cout << "Anzahl States auf dem direct Walk: "<<scc.size()<<endl;

	
	delete rng;
	
  	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}



