

#include <ell/LT_BarrierTree.hh>

#include "DummyState.hh"

using namespace ell;

int main(int argc, char** argv) {
	
	
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : LT_BarrierTree\n"
				<<"===========================================" <<std::endl;


	std::cout	<< "=> creating LT_BarrierTree bt" << std::endl;
	LT_BarrierTree bt;
	
	  // vector of my dummy states
	std::vector<DummyState> s;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_1", 3, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_2", 5, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_3", 4, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_4", 1, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_0", 2, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	
	std::cout	<< "=> adding states to the set" <<std::endl;
	for (size_t i=0; i<s.size(); i++) {
		std::cout <<" ."; std::cout.flush();
		bt.addMin(&s[i]);
	}
	std::cout <<std::endl;

	std::cout	<< std::endl;
	std::vector<DummyState> barrier;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_1", 8, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 2, 3, barrier_1)"<<std::endl;;
	bt.addSaddle(&s[2], &s[3], &barrier[0]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_2", 9, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 1, 0, barrier_2)"<<std::endl;;
	bt.addSaddle(&s[1], &s[0], &barrier[1]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_3", 12, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 4, 1, barrier_3)"<<std::endl;;
	bt.addSaddle(&s[4], &s[1], &barrier[2]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_4", 11, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 2, 4, barrier_4)"<<std::endl;;
	bt.addSaddle(&s[2], &s[4], &barrier[3]);
	
	std::cout	<< std::endl;
	std::cout	<< "=> bt.getMinCount() = " <<bt.getMinCount() <<std::endl;
	std::cout	<< "=> bt.getMinIndex("<<s[2].toString()<<") = " <<bt.getMinIndex(&s[2]) <<std::endl;
	std::cout	<< "=> bt.getMin("<<bt.getMinIndex(&s[2])<<") = " <<bt.getMin(bt.getMinIndex(&s[2]))->toString() <<std::endl;
	std::cout	<< "=> bt.getMFEState()->toString() = " <<bt.getMFEState()->toString() <<std::endl;
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_5", 10, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 1, 2, barrier_5)"<<std::endl;;
	bt.addSaddle(&s[1], &s[2], &barrier[4]);
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_5", 3, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addMin( state_5 )"<<std::endl;;
	bt.addMin(&(*s.rbegin()));
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_6", 8, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 4, 5, barrier_6)"<<std::endl;;
	bt.addSaddle(&s[4], &s[5], &barrier[5]);
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_7", 8, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 4, 3, barrier_7)"<<std::endl;;
	bt.addSaddle(&s[4], &s[3], &barrier[6]);
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_8", 6, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 2, 3, barrier_8)"<<std::endl;;
	bt.addSaddle(&s[2], &s[3], &barrier[7]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_9", 6, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 4, 5, barrier_9)"<<std::endl;;
	bt.addSaddle(&s[4], &s[5], &barrier[8]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_10", 7, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 0, 2, barrier_10)"<<std::endl;;
	bt.addSaddle(&s[0], &s[2], &barrier[9]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_11", 7, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 1, 5, barrier_11)"<<std::endl;;
	bt.addSaddle(&s[1], &s[5], &barrier[10]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	barrier.push_back(DummyState("barrier_12", 6, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 3, 4, barrier_12)"<<std::endl;;
	bt.addSaddle(&s[3], &s[4], &barrier[11]);
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout,  true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	barrier.push_back(DummyState("barrier_13", 4, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 0, 2, barrier_13)"<<std::endl;;
	bt.addSaddle(&s[0], &s[2], &barrier[12]);
	std::cout	<< "=> bt.write(std::cout,  true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, false);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 3, 2, barrier_13)"<<std::endl;;
	bt.addSaddle(&s[3], &s[2], &barrier[12]);
	barrier.push_back(DummyState("barrier_14", 3, 20));
	std::cout	<< "   " <<barrier.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.addSaddle( 2, 3, barrier_14)"<<std::endl;;
	bt.addSaddle(&s[3], &s[0], &barrier[13]);
	
	std::cout	<< "=> bt.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;


	
	std::cout	<< "=> bt.isSorted() = " <<(bt.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> bt.sort()" <<std::endl;
	bt.sort();
	std::cout	<< "=> bt.isSorted() = " <<(bt.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> bt.getMFEState()->toString() = " <<bt.getMFEState()->toString() <<std::endl;
	std::cout	<< "=> bt.write(std::cout)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> bt.write_PStree(stringstream)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::stringstream ss;
	bt.write_PStree(ss);
	std::cout	<< "-> ss.str.size() = " <<ss.str().size() <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;

	
	
	LT_BarrierTree bt2;
	std::cout	<< "=> creating LT_BarrierTree bt2" << std::endl;
	ss.clear();
	bt.write(ss);
	std::cout	<< "=> bt2.read( bt.write )" <<std::endl;
	std::pair<int,std::string> res = bt2.read(ss,&s[0]);
	std::cout	<< "   -> result = ( " <<res.first <<", '" <<res.second <<"' )" <<std::endl;
	std::cout	<< "=> bt2.write(std::cout)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt2.write(std::cout);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> bt2.isSorted() = " <<(bt2.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> bt2.getMFEState() = " <<(bt2.getMFEState()==NULL?"NULL":bt2.getMFEState()->toString()) <<std::endl;
	
	
	std::cout	<< "=> bt.getDistance(bt2) = "; std::cout.flush();
	std::cout	<<bt.getDistance(&bt2) <<std::endl;
	
	
	std::cout	<< "=> assignment bt2 = bt" << std::endl;
	bt2 = bt;
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt2.write(std::cout);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> bt2.isSorted() = " <<(bt2.isSorted()?"true":"false") <<std::endl;
	
	std::cout	<< "=> bt.getDistance(bt2) = " <<bt.getDistance(&bt2) <<std::endl;
	
	std::cout	<< "=> copy construction bt3 = LT_BarrierTree(bt)" << std::endl;
	LT_BarrierTree bt3(bt);
	std::cout	<< "-----------------------------------------" <<std::endl;
	bt3.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> bt3.isSorted() = " <<(bt3.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> bt.getDistance(bt3) = " <<bt.getDistance(&bt3) <<std::endl;


	
	
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_X", 1, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> bt.getMinIndex("<<s.rbegin()->toString()<<") == INVALID_INDEX ? = " <<(bt.getMinIndex(&(*s.rbegin()))==LandscapeTopology::INVALID_INDEX?"true":"false") <<std::endl;

	std::cout	<< "=> bt2.clear() " <<std::endl;
	bt2.clear();
	std::cout	<< "=> bt2.getMinCount() = " <<bt2.getMinCount() <<std::endl;
	

	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}
