

#include <ell/LT_SaddleNet.hh>

#include "DummyState.hh"

using namespace ell;

int main(int argc, char** argv) {
	
	
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : LT_SaddleNet_AM\n"
				<<"===========================================" <<std::endl;


	std::cout	<< "=> creating LT_SaddleNet_AM sn" << std::endl;
	LT_SaddleNet_AM sn;
	
	
	  // vector of my dummy states
	std::vector<DummyState> s;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_1", 3, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_2", 5, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_3", 4, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_4", 1, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_0", 2, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	
	std::cout	<< "=> adding states to the set" <<std::endl;
	for (size_t i=0; i<s.size(); i++) {
		std::cout <<" ."; std::cout.flush();
		sn.addMin(&s[i]);
	}
	std::cout <<std::endl;


	
	
	
	std::cout	<< std::endl;
	std::vector<DummyState> saddle;
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_1", 8, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 2, 3, saddle_1)"<<std::endl;;
	sn.addSaddle(&s[2], &s[3], &saddle[0]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_2", 9, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 1, 0, saddle_2)"<<std::endl;;
	sn.addSaddle(&s[1], &s[0], &saddle[1]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_3", 12, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 4, 1, saddle_3)"<<std::endl;;
	sn.addSaddle(&s[4], &s[1], &saddle[2]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_4", 11, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 2, 4, saddle_4)"<<std::endl;;
	sn.addSaddle(&s[2], &s[4], &saddle[3]);
	
	std::cout	<< std::endl;
	std::cout	<< "=> sn.getMinCount() = " <<sn.getMinCount() <<std::endl;
	std::cout	<< "=> sn.getMinIndex("<<s[2].toString()<<") = " <<sn.getMinIndex(&s[2]) <<std::endl;
	std::cout	<< "=> sn.getMin("<<sn.getMinIndex(&s[2])<<") = " <<sn.getMin(sn.getMinIndex(&s[2]))->toString() <<std::endl;
	std::cout	<< "=> sn.getMFEState()->toString() = " <<sn.getMFEState()->toString() <<std::endl;
	
	std::cout	<< "=> sn.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout,  true);
	std::cout	<< "-----------------------------------------" <<std::endl;
	
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_5", 10, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 1, 2, saddle_5)"<<std::endl;;
	sn.addSaddle(&s[1], &s[2], &saddle[4]);
	
	std::cout	<< "=> sn.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_5", 3, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addMin( state_5 )"<<std::endl;;
	sn.addMin(&(*s.rbegin()));
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_6", 8, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 4, 5, saddle_6)"<<std::endl;;
	sn.addSaddle(&s[4], &s[5], &saddle[5]);
	
	std::cout	<< "=> sn.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout,  true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_7", 8, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 4, 3, saddle_7)"<<std::endl;;
	sn.addSaddle(&s[4], &s[3], &saddle[6]);
	
	std::cout	<< "=> sn.write(std::cout, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout, true);
	std::cout	<< "-----------------------------------------" <<std::endl;

	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_8", 6, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 2, 3, saddle_8)"<<std::endl;;
	sn.addSaddle(&s[2], &s[3], &saddle[7]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_9", 6, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 4, 5, saddle_9)"<<std::endl;;
	sn.addSaddle(&s[4], &s[5], &saddle[8]);
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	saddle.push_back(DummyState("saddle_10", 7, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 0, 2, saddle_10)"<<std::endl;;
	sn.addSaddle(&s[0], &s[2], &saddle[9]);
	saddle.push_back(DummyState("saddle_11", 7, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 1, 5, saddle_11)"<<std::endl;;
	sn.addSaddle(&s[1], &s[5], &saddle[10]);
	saddle.push_back(DummyState("saddle_12", 6, 20));
	std::cout	<< "   " <<saddle.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.addSaddle( 3, 4, saddle_12)"<<std::endl;;
	sn.addSaddle(&s[3], &s[4], &saddle[11]);

	
	std::cout	<< "=> sn.write(std::cout, Dummy, true)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout,  true);
	std::cout	<< "-----------------------------------------" <<std::endl;


	
	std::cout	<< "=> sn.isSorted() = " <<(sn.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> sn.sort()" <<std::endl;
	sn.sort();
	std::cout	<< "=> sn.isSorted() = " <<(sn.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> sn.getMFEState()->toString() = " <<sn.getMFEState()->toString() <<std::endl;
	std::cout	<< "=> sn.getSaddleNumber() = " <<sn.getSaddleNumber() <<std::endl;
	std::cout	<< "=> sn.getAvgSaddleEnergy() = " <<sn.getAvgSaddleEnergy() <<std::endl;
	std::cout	<< "=> sn.write(std::cout)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn.write(std::cout );
	std::cout	<< "-----------------------------------------" <<std::endl;
	
	LT_SaddleNet_AM sn2;
	std::cout	<< "=> creating LT_SaddleNet_AM sn2" << std::endl;
	std::stringstream ss;
	sn.write(ss );
	std::cout	<< "=> sn2.read( sn.write )" <<std::endl;
	std::pair<int,std::string> res = sn2.read(ss,&s[0] );
	std::cout	<< "   -> result = ( " <<res.first <<", '" <<res.second <<"' )" <<std::endl;
	std::cout	<< "=> sn2.write(std::cout)" <<std::endl;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn2.write(std::cout );
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> sn2.isSorted() = " <<(sn2.isSorted()?"true":"false") <<std::endl;
	
	std::cout	<< "=> sn.getDistance(sn2) = " <<sn.getDistance(&sn2) <<std::endl;
	
	
	std::cout	<< "=> assignment sn2 = sn" << std::endl;
	sn2 = sn;
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn2.write(std::cout );
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> sn2.isSorted() = " <<(sn2.isSorted()?"true":"false") <<std::endl;
	
	std::cout	<< "=> sn.getDistance(sn2) = " <<sn.getDistance(&sn2) <<std::endl;
	
	std::cout	<< "=> copy construction sn3 = LT_SaddleNet_AM(sn)" << std::endl;
	LT_SaddleNet_AM sn3(sn);
	std::cout	<< "-----------------------------------------" <<std::endl;
	sn3.write(std::cout,  true);
	std::cout	<< "-----------------------------------------" <<std::endl;
	std::cout	<< "=> sn3.isSorted() = " <<(sn3.isSorted()?"true":"false") <<std::endl;
	std::cout	<< "=> sn.getDistance(sn3) = " <<sn.getDistance(&sn3) <<std::endl;



	
	std::cout	<< "=> creating DummyState "; std::cout.flush();
	s.push_back(DummyState("state_X", 1, 20));
	std::cout	<< "   " <<s.rbegin()->toString() <<std::endl;
	std::cout	<< "=> sn.getMinIndex("<<s.rbegin()->toString()<<") == INVALID_INDEX ? = " <<(sn.getMinIndex(&(*s.rbegin()))==LandscapeTopology::INVALID_INDEX?"true":"false") <<std::endl;

	std::cout	<< "=> sn2.clear() " <<std::endl;
	sn2.clear();
	std::cout	<< "=> sn2.getMinCount() = " <<sn2.getMinCount() <<std::endl;
	

	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}
