#include "ell/rna/RNAFreeEnergy_TB.hh"
#include <iostream>

using namespace ell;

void testRNAFreeEnergy_TB( ell::RNAFreeEnergy_TB rnaStruct, 
			const std::string &seqStr, 
			const std::string &structStr) 
{
		// ==
	std::cout	<<"->(*this == *this)  = "
				<<(rnaStruct == rnaStruct ?"true":"false")
				<<std::endl;
	
		// !=
	std::cout	<<"->(*this != *this)  = "
				<<(rnaStruct == rnaStruct ?"true":"false")
				<<std::endl;
	
		// hasValidStructure()
	std::cout	<<"->hasValidStructure()  = "
				<<(rnaStruct.hasValidStructure() ? "true":"false")
				<<std::endl;
	
		// hasValidBasePairs()
	std::cout	<<"->hasValidBasePairs()  = "
				<<(rnaStruct.hasValidBasePairs() ? "true":"false")
				<<std::endl;
	
		// getMinLoopLength()
	std::cout	<<"->getMinLoopLength()  = "
				<<rnaStruct.getMinLoopLength()
				<<std::endl;
	
		// hasMinLoopLength()
	std::cout	<<"->hasValidLoopSize()  = "
				<<(rnaStruct.hasValidLoopSize() ? "true":"false")
				<<std::endl;
	
		// isAllowedBasePair() = false
	std::cout	<<"->isAllowedBasePair(0,4)  = "
				<<(rnaStruct.isAllowedBasePair(0,4) ? "true":"false")
				<<std::endl;
	
		// isAllowedBasePair() = true
	std::cout	<<"->isAllowedBasePair(1,7)  = "
				<<(rnaStruct.isAllowedBasePair(1,7) ? "true":"false")
				<<std::endl;
	
		// getClosingBond(2)
	std::cout	<<"->getCorrespondingBase(2)  = "
				<<rnaStruct.getCorrespondingBase(2)
				<<std::endl;
	
		// getClosingBond(3)
	std::cout	<<"->getCorrespondingBase(3)  == INVALID_INDEX "
				<< ( rnaStruct.getCorrespondingBase(3)== biu::RNAStructure_TB::INVALID_INDEX
					 ? "true":"false")
				<<std::endl;
	
		// getSequenceString()
	std::cout	<<"->RNAFreeEnergy_TB::getSequenceString() = "
				<<rnaStruct.getSequenceString()
				<<std::endl;
	
		// getStructureString()
	std::cout	<<"->RNAFreeEnergy_TB::getStructureString() = "
				<<rnaStruct.getStructureString()
				<<std::endl;
	
		// getSequence()
	std::cout	<<"->RNAFreeEnergy_TB::getSequenceAlphabet()->getString("
				<<" rnaStruct.getSequence())  = "
				<<RNAFreeEnergy_TB::getSequenceAlphabet()
				   ->getString(rnaStruct.getSequence())
				<<std::endl;
	std::cout	<<"->RNAFreeEnergy_TB::getSequenceAlphabet()->getString("
				<<" rnaStruct.getSequence()) == seqStr)  = "
				<<(RNAFreeEnergy_TB::getSequenceAlphabet()
				   ->getString(rnaStruct.getSequence()) == seqStr ? 
						"true":"false")
				<<std::endl;
	
		// getStructure()
	std::cout	<<"->RNAFreeEnergy_TB::getStructureAlphabet()->getString("
				<<" rnaStruct.getStructure()  = "
				<<RNAFreeEnergy_TB::getStructureAlphabet()
				  ->getString(rnaStruct.getStructure())
				<<std::endl;
	std::cout	<<"->(RNA::FreeEnergy::getStructureAlphabet()>getString("
				<<" rnaStruct.getStructure()) == structStr)  = "
				<<(RNAFreeEnergy_TB::getStructureAlphabet()
				  ->getString(rnaStruct.getStructure()) == structStr ? 
						"true":"false")
				<<std::endl;
	
		// isValid()
	std::cout	<<"->isValid()  = "
				<<(rnaStruct.isValid() ? "true":"false")
				<<std::endl;
	
		// getStringRepresentation()
	std::cout	<<"->getStringRepresentation()  = "
				<<rnaStruct.getStringRepresentation()
				<<std::endl;
	
		// getEnergy()
	std::cout	<<"->getEnergy()  = "
				<<rnaStruct.getEnergy()
				<<std::endl;
	
	RNAFreeEnergy_TB::SingleMove s15(1,5);
	std::cout	<<"=> creating SingleMove (" 
				<<s15.first <<","<<s15.second <<") = s15"
				<<std::endl;
	RNAFreeEnergy_TB::SingleMove s17(1,7);
	std::cout	<<"=> creating SingleMove (" 
				<<s17.first <<","<<s17.second <<") = s17"
				<<std::endl;
				
		// isValidSingleMove() == false
	std::cout	<<"->isValidSingleMove(s15)  = "
				<<(rnaStruct.isValidSingleMove(s15) ?"true":"false")
				<<std::endl;
	
		// isValidSingleMove() == true
	std::cout	<<"->isValidSingleMove(s17)  = "
				<<(rnaStruct.isValidSingleMove(s17) ?"true":"false")
				<<std::endl;
	
		// ->getStructureString()
	std::cout	<<"->getStructureString()  = "
				<<rnaStruct.getStructureString()
				<<std::endl;
	
		// applySingleMoveInPlace()
	if (rnaStruct.isValidSingleMove(s17)) {
		std::cout	<<"->applySingleMoveInPlace(s17)" <<std::endl;
			rnaStruct.applySingleMoveInPlace(s17);
	}
	
		// getStructureString()
	std::cout	<<"->getStructureString()  = "
				<<rnaStruct.getStructureString()
				<<std::endl;
	
		// getNextSingleMove(0,3)
	size_t i=0, j=3;
	bool ret = rnaStruct.getNextSingleMove(i,j);
	std::cout	<<"->getNextSingleMove(0,3)  = "
				<<(ret?"true":"false")
				<<" = ("
				<<i <<"," <<j<<")"
				<<std::endl;	
}

int main(int argc, char **argv) {

	using namespace ell;

	std::cout	<<"========== BEGIN OF TEST =================\n"
				<<" test class : RNAFreeEnergy_TB\n"
				<<"==========================================" <<std::endl;

	{
			std::string seqStr = "GGCAAAGUCAAAGAU";
		std::cout	<<"=> " <<seqStr <<" = seqStr" <<std::endl;
			std::string structStr = "..(...).(...)..";
		std::cout	<<"=> " <<structStr <<" = structStr" <<std::endl;
	
		std::cout	<<"\n==========================================" 
					<<"\n test with copied sequence"
					<<"\n==========================================\n" <<std::endl;
		
		std::cout	<<"=> create ell::RNAFreeEnergy_TB(seqStr, structStr)" 
					<<std::endl;
		RNAFreeEnergy_TB rnaStruct(seqStr, structStr);
		
		testRNAFreeEnergy_TB(rnaStruct,seqStr, structStr);
	
		std::cout	<<"\n==========================================" 
					<<"\n test with shared sequence"
					<<"\n==========================================\n" <<std::endl;
		
		std::cout	<<"=> create rnaSeq = ell::RNAFreeEnergy_TB::COMMON_ALPHABET.getSequence(seqStr)" <<std::endl;
		biu::Sequence rnaSeq = ell::RNAFreeEnergy_TB::getSequenceAlphabet()->getSequence(seqStr);
		std::cout	<<"=> create rnaStr = ell::RNAFreeEnergy_TB::STRUCT_ALPHABET.getSequence(structStr)" <<std::endl;
		biu::Structure rnaStr = ell::RNAFreeEnergy_TB::getStructureAlphabet()->getSequence(structStr);
		std::cout	<<"=> create ell::RNAFreeEnergy_TB( rnaSeq, rnaStr, shared=true)" 
					<<std::endl;
		RNAFreeEnergy_TB rnaStruct2(&rnaSeq,&rnaStr, true);
		
		testRNAFreeEnergy_TB(rnaStruct2,seqStr, structStr);
	}

	
	
	
	std::cout	<<"============= END OF TEST ================\n" <<std::endl;
	
	return 0;
}
