#include "ell/WalkAbortionCriterion.hh"
#include "ell/State.hh"
#include <iostream>

#include "DummyState.hh"

using namespace ell;



int main(int argc, char** argv)
{
	
	/*
	 * Test WAC_MaxEnergy
	 */
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : WAC_MaxEnergy\n"
				<<"===========================================" <<std::endl;

	std::cout << "=> creating DummyState(\"State 1\", 5)" << std::endl;
	State* s = new DummyState("State 1", 5, 5);
	std::cout << "->getEnergy = " << s->getEnergy() << std::endl;
	std::cout << "=> creating StateCollector sc" << std::endl;
	StateCollector* sc = new SC_Counting();
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	
	std::cout << "=> creating WAC_MaxEnergy(4)" << std::endl;
	WalkAbortionCriterion* wacMaxEnergy = new WAC_MaxEnergy(4);
	std::cout << "->abort(sc) = " << wacMaxEnergy->abort(sc) << std::endl;
	
	std::cout << "=> creating WAC_MaxEnergy(6)" << std::endl;
	delete wacMaxEnergy;
	wacMaxEnergy = new WAC_MaxEnergy(6);
	std::cout << "->abort(sc) = " << wacMaxEnergy->abort(sc) << std::endl;
	
	delete s;
	delete sc;
	delete wacMaxEnergy;
	
	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	
	/*
	 * Test WAC_MinEnergy
	 */
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : WAC_MinEnergy\n"
				<<"===========================================" <<std::endl;
	std::cout << "=> creating DummyState(\"State 1\", 5)" << std::endl;
	s = new DummyState("State 1", 5, 5);
	std::cout << "->getEnergy = " << s->getEnergy() << std::endl;
	std::cout << "=> creating StateCollector sc" << std::endl;
	sc = new SC_Counting();
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	
	std::cout << "=> creating WAC_MinEnergy(4)" << std::endl;
	WalkAbortionCriterion* wacMinEnergy = new WAC_MinEnergy(4);
	std::cout << "->abort(sc) = " << wacMinEnergy->abort(sc) << std::endl;
		
	std::cout << "=> creating WAC_MinEnergy(6)" << std::endl;
	delete wacMinEnergy;
	wacMinEnergy = new WAC_MinEnergy(6);
	std::cout << "->abort(sc) = " << wacMinEnergy->abort(sc) << std::endl;
	
	delete s;
	delete sc;
	delete wacMinEnergy;

	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	/*
	 * Test WAC_MaxLength
	 */
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : WAC_MaxLength\n"
				<<"===========================================" <<std::endl;
	std::cout << "=> creating DummyState(\"State 1\", 5)" << std::endl;
	s = new DummyState("State 1", 5, 5);
	std::cout << "=> creating StateCollector sc" << std::endl;
	sc = new SC_Counting();
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	std::cout << "->add(*s)" << std::endl;
	sc->add(*s);
	std::cout << "->size: " << sc->size() << std::endl;
	
	std::cout << "=> creating WAC_MaxLength(4)" << std::endl;
	WalkAbortionCriterion* wacMaxLength = new WAC_MaxLength(4);
	std::cout << "->abort(sc) = " << wacMaxLength->abort(sc) << std::endl;
		
	std::cout << "=> creating WAC_MaxLength(6)" << std::endl;
	delete wacMaxLength;
	wacMaxLength = new WAC_MaxLength(6);
	std::cout << "->abort(sc) = " << wacMaxLength->abort(sc) << std::endl;
	
	delete s;
	delete sc;
	delete wacMaxLength;

	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
	
	return 0;
}
