#include "ell/Walk.hh"
#include "ell/State.hh"
#include <iostream>
#include <string>
#include <vector>

using namespace ell;

#include "DummyState.hh"



int main(int argc, char **argv) {
	
	std::cout	<<"========== BEGIN OF TEST ==================\n"
				<<" test class : walkGradient\n"
				<<"===========================================" <<std::endl;

	std::cout	<< "=> creating DummyState" << std::endl;
	State* state = new DummyState("state 1", 20, 5);
	std::cout	<< "->getEnergy = " << state->getEnergy() << std::endl;

	std::cout	<< "=> creating StateCollector" << std::endl;
	StateCollector* sc = new SC_Listing();

	std::cout	<< "=> calling walk" << std::endl;
	sc = WalkGradient::walkGradient(state, sc);
	
	std::cout 	<< "Number Of Accepted States: " 
					<< sc->size()
					<< std::endl;
	
	SC_Listing* sch;
	sch = dynamic_cast<SC_Listing*>(sc);
	
	std::cout 	<< "Accepted States:" << std::endl;
	SC_Listing::List list = sch->getList();
	SC_Listing::List::iterator iter;
  	for( iter = list.begin(); iter != list.end(); iter++ ) {
    	std::cout 	<< "  * Energy = "
    				<< (*iter)->getEnergy() << std::endl;
  	}
	
  	delete state;
  	delete sc;
  	
  	std::cout	<<"============= END OF TEST =================\n" <<std::endl;
  	
	return 0; 
}
